"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Duration = _interopRequireDefault(require("../components/Duration"));

var _locale = require("../locale");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = {
  title: `{{t("Delay", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'delay',
  group: 'control',
  fieldset: {
    'config.duration': {
      type: 'number',
      name: 'config.duration',
      title: `{{t("Duration", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Duration',
      default: 60000
    },
    'config.endStatus': {
      type: 'number',
      name: 'config.endStatus',
      title: `{{t("End Status", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'Select',
      'x-component-props': {
        placeholder: `{{t("Select status", { ns: "${_locale.NAMESPACE}" })}}`
      },
      enum: [{
        label: `{{t("Succeed and continue", { ns: "${_locale.NAMESPACE}" })}}`,
        value: 1
      }, {
        label: `{{t("Fail and exit", { ns: "${_locale.NAMESPACE}" })}}`,
        value: -1
      }]
    }
  },
  view: {},
  scope: {},
  components: {
    Duration: _Duration.default
  }
};
exports.default = _default;