"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _antd() {
  const data = require("antd");

  _antd = function _antd() {
    return data;
  };

  return data;
}

function _client() {
  const data = require("@nocobase/client");

  _client = function _client() {
    return data;
  };

  return data;
}

var _ScheduleConfig = require("./ScheduleConfig");

var _FlowContext = require("../../FlowContext");

var _calculators = require("../../calculators");

var _constants = require("./constants");

var _locale = require("../../locale");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = {
  title: `{{t("Schedule event", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'schedule',
  fieldset: {
    config: {
      type: 'object',
      name: 'config',
      'x-component': 'ScheduleConfig',
      'x-component-props': {}
    }
  },
  scope: {
    useCollectionDataSource: _client().useCollectionDataSource
  },
  components: {
    ScheduleConfig: _ScheduleConfig.ScheduleConfig
  },

  getOptions(config) {
    const _useWorkflowTranslati = (0, _locale.useWorkflowTranslation)(),
          t = _useWorkflowTranslati.t;

    const options = [{
      value: 'date',
      label: t('Trigger time')
    }];

    if (config.mode === _constants.SCHEDULE_MODE.COLLECTION_FIELD) {
      options.push({
        value: 'data',
        label: t('Trigger data')
      });
    }

    return options;
  },

  getter({
    onChange: _onChange
  }) {
    var _collections$find;

    const _useWorkflowTranslati2 = (0, _locale.useWorkflowTranslation)(),
          t = _useWorkflowTranslati2.t;

    const compile = (0, _client().useCompile)();

    const _useCollectionManager = (0, _client().useCollectionManager)(),
          _useCollectionManager2 = _useCollectionManager.collections,
          collections = _useCollectionManager2 === void 0 ? [] : _useCollectionManager2;

    const _useFlowContext = (0, _FlowContext.useFlowContext)(),
          workflow = _useFlowContext.workflow;

    const _useOperandContext = (0, _calculators.useOperandContext)(),
          options = _useOperandContext.options;

    const path = (options === null || options === void 0 ? void 0 : options.path) ? options.path.split('.') : [];

    if (!options.type || options.type === 'date') {
      return null;
    }

    const collection = (_collections$find = collections.find(item => item.name === workflow.config.collection)) !== null && _collections$find !== void 0 ? _collections$find : {
      fields: []
    };
    return _react().default.createElement(_antd().Cascader, {
      placeholder: t('Trigger data'),
      value: path,
      options: collection.fields.filter(field => {
        var _field$uiSchema;

        return _calculators.BaseTypeSet.has(field === null || field === void 0 ? void 0 : (_field$uiSchema = field.uiSchema) === null || _field$uiSchema === void 0 ? void 0 : _field$uiSchema.type);
      }).map(field => {
        var _field$uiSchema2;

        return {
          value: field.name,
          label: compile((_field$uiSchema2 = field.uiSchema) === null || _field$uiSchema2 === void 0 ? void 0 : _field$uiSchema2.title)
        };
      }),
      onChange: next => {
        _onChange(`{{$context.${next.join('.')}}}`);
      },
      allowClear: false
    });
  }

};
exports.default = _default;