"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _constants = require("../constants");

function _ejs() {
  const data = require("ejs");

  _ejs = function _ejs() {
    return data;
  };

  return data;
}

function _axios() {
  const data = _interopRequireDefault(require("axios"));

  _axios = function _axios() {
    return data;
  };

  return data;
}

function _lodash() {
  const data = _interopRequireDefault(require("lodash"));

  _lodash = function _lodash() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function renderData(_x, _x2) {
  return _renderData.apply(this, arguments);
}

function _renderData() {
  _renderData = _asyncToGenerator(function* (templateStr, vars) {
    if (_lodash().default.isEmpty(templateStr)) {
      return '';
    }

    return (0, _ejs().render)(templateStr, vars, {
      async: true
    });
  });
  return _renderData.apply(this, arguments);
}

function triggerResume(_x3, _x4, _x5, _x6) {
  return _triggerResume.apply(this, arguments);
}

function _triggerResume() {
  _triggerResume = _asyncToGenerator(function* (plugin, job, status, result) {
    job.set('status', status);
    job.set('result', result);
    return plugin.resume(job);
  });
  return _triggerResume.apply(this, arguments);
}

class _default {
  run(node, input, processor) {
    return _asyncToGenerator(function* () {
      const templateVars = {
        node: processor.jobsMapByNodeId,
        ctx: processor.execution.context
      };
      const requestConfig = node.config; // default headers

      const headers = {
        'Content-Type': 'application/json'
      };
      const _requestConfig$header = requestConfig.headers,
            headerArr = _requestConfig$header === void 0 ? [] : _requestConfig$header,
            _requestConfig$ignore = requestConfig.ignoreFail,
            ignoreFail = _requestConfig$ignore === void 0 ? false : _requestConfig$ignore,
            _requestConfig$method = requestConfig.method,
            method = _requestConfig$method === void 0 ? 'POST' : _requestConfig$method,
            _requestConfig$timeou = requestConfig.timeout,
            timeout = _requestConfig$timeou === void 0 ? 5000 : _requestConfig$timeou;
      headerArr.forEach(header => headers[header.name] = header.value);
      let url, data;

      try {
        url = yield renderData(requestConfig.url, templateVars);
      } catch (e) {
        console.warn(e);
        throw new Error(`ejs can't render url, please check url format！${e === null || e === void 0 ? void 0 : e.message}`);
      }

      try {
        data = yield renderData(requestConfig.data, templateVars);
      } catch (e) {
        console.warn(e);
        throw new Error(`ejs can't render request data, please check request data format！${e === null || e === void 0 ? void 0 : e.message}`);
      }

      const job = yield processor.saveJob({
        status: _constants.JOB_STATUS.PENDING,
        nodeId: node.id
      });
      const plugin = processor.options.plugin;

      _axios().default.request({
        method,
        timeout,
        headers,
        url,
        data
      }).then(resp => {
        if (resp.status >= 200 && resp.status < 300) {
          triggerResume(plugin, job, _constants.JOB_STATUS.RESOLVED, resp.data);
        } else {
          triggerResume(plugin, job, _constants.JOB_STATUS.REJECTED, resp);
        }
      }).catch(e => {
        console.warn(e);
        triggerResume(plugin, job, _constants.JOB_STATUS.REJECTED, e === null || e === void 0 ? void 0 : e.message);
      });

      return job;
    })();
  }

  resume(node, job, processor) {
    return _asyncToGenerator(function* () {
      const ignoreFail = node.config.ignoreFail;

      if (ignoreFail) {
        job.set('status', _constants.JOB_STATUS.RESOLVED);
      }

      return job;
    })();
  }

}

exports.default = _default;