"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _server() {
  const data = require("@nocobase/server");

  _server = function _server() {
    return data;
  };

  return data;
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const VTypes = {
  constant(operand) {
    return operand.value;
  },

  $jobsMapByNodeId({
    options
  }) {
    const paths = [options.nodeId, options.path].filter(Boolean);
    return paths ? `{{$jobsMapByNodeId.${paths.join('.')}}}` : null;
  },

  $context({
    options
  }) {
    return `{{$context.${options.path}}}`;
  }

};

function migrateConfig(config) {
  if (Array.isArray(config)) {
    return config.map(item => migrateConfig(item));
  }

  if (typeof config !== 'object') {
    return config;
  }

  if (!config) {
    return config;
  }

  if (config.type && VTypes[config.type] && (config.options || config.value)) {
    return VTypes[config.type](config);
  }

  return Object.keys(config).reduce((memo, key) => _objectSpread(_objectSpread({}, memo), {}, {
    [key]: migrateConfig(config[key])
  }), {});
}

class _default extends _server().Migration {
  up() {
    var _this = this;

    return _asyncToGenerator(function* () {
      const match = yield _this.app.version.satisfies('<=0.8.0-alpha.13');

      if (!match) {
        return;
      }

      const NodeRepo = _this.context.db.getRepository('flow_nodes');

      yield _this.context.db.sequelize.transaction( /*#__PURE__*/function () {
        var _ref = _asyncToGenerator(function* (transaction) {
          const nodes = yield NodeRepo.find({
            filter: {
              type: {
                $or: ['calculation', 'condition']
              }
            },
            transaction
          });
          console.log('%d nodes need to be migrated.', nodes.length);
          yield nodes.reduce((promise, node) => {
            return node.update({
              config: migrateConfig(node.config)
            }, {
              transaction
            });
          }, Promise.resolve());
        });

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }());
    })();
  }

  down() {
    return _asyncToGenerator(function* () {})();
  }

}

exports.default = _default;